<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "ehr_communication_queue".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "EhrCommunicationQueue".
 *
 * Columns in table "ehr_communication_queue" available as properties of the model,
 * followed by relations of table "ehr_communication_queue" available as properties of the model.
 *
 * @property integer $id
 * @property integer $emr_id
 * @property string $emr_location_id
 * @property string $endpoint
 * @property integer $message_type
 * @property string $message
 * @property integer $processed
 * @property integer $success
 * @property string $results
 * @property string $entity_type
 * @property string $entity_value
 * @property string $date_added
 * @property string $date_updated
 *
 * @property AccountEmr $emr
 */
abstract class BaseEhrCommunicationQueue extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'ehr_communication_queue';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'EhrCommunicationQueue|EhrCommunicationQueues', $n);
    }

    public static function representingColumn()
    {
        return 'emr_location_id';
    }

    public function rules()
    {
        return array(
            array('emr_id', 'required'),
            array('emr_id, message_type, processed, success', 'numerical', 'integerOnly' => true),
            array('emr_location_id', 'length', 'max' => 25),
            array('entity_type, entity_value', 'length', 'max' => 20),
            array('message, results, date_added, date_updated', 'safe'),
            array('endpoint, message_type, message, processed, success, results, date_added, date_updated, entity_type, entity_value', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, emr_id, emr_location_id, endpoint, message_type, message, processed, success, results, date_added, date_updated', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'emr' => array(self::BELONGS_TO, 'AccountEmr', 'emr_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'emr_id' => null,
            'emr_location_id' => Yii::t('app', 'Emr Location'),
            'endpoint' => Yii::t('app', 'Endpoint'),
            'message_type' => Yii::t('app', 'Message Type'),
            'message' => Yii::t('app', 'Message'),
            'processed' => Yii::t('app', 'Processed'),
            'success' => Yii::t('app', 'Success'),
            'results' => Yii::t('app', 'Results'),
            'entity_type' => Yii::t('app', 'Entity Type'),
            'entity_value' => Yii::t('app', 'Entity Value'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'emr' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('emr_id', $this->emr_id);
        $criteria->compare('emr_location_id', $this->emr_location_id, true);
        $criteria->compare('endpoint', $this->endpoint, true);
        $criteria->compare('message_type', $this->message_type);
        $criteria->compare('message', $this->message, true);
        $criteria->compare('processed', $this->processed);
        $criteria->compare('success', $this->success);
        $criteria->compare('results', $this->results, true);
        $criteria->compare('entity_type', $this->entity_type, true);
        $criteria->compare('entity_value', $this->entity_value, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
